/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (I)         *
 *            - vO~O̊bE\[XECxg -             *
 *                                                                     *
 *      Copyright 1994,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <X11/keysym.h> /* L[V{̒`wb_Et@C */
#include <Xm/XmAll.h>

static GC gc;  /* OtBbNEReLXg (Xlib ł̕`ɕKv) */

/* [U͂ƂɌĂяoR[obN֐ */
static void InputEventCB(w, client_data, call_data)
    Widget    w;            /* R[obNo^ĂEBWFbg */
    XtPointer client_data;  /* o^ɓnĂNCAgEf[^ */
    XtPointer call_data;    /* R[obN\ */
{
    /* (2) R[obN\ call_data  cb ɑ */
    XmDrawingAreaCallbackStruct *cb = (XmDrawingAreaCallbackStruct *)call_data;
    int x, y;       /* {^ꂽꏊ̍W */
    KeySym keysym;  /* ͂ꂽL[V{ */

    /* cb->event ̓Cxg\                   */
    /*         cb->event->type ̓Cxg̃^Cv */
    /*                                          */
    if (cb->event->type == ButtonPress &&        /* (3) {^ꂽꍇ */
        cb->event->xbutton.button == Button1) {  /* (4) ꂽ̂̓{^P */
        x = cb->event->xbutton.x;  /* (5) {^ꂽꏊ̂wW */
        y = cb->event->xbutton.y;  /* (5) {^ꂽꏊ̂xW */
        /* (6) {^ꂽʒuɐ`` */
        XDrawRectangle(XtDisplay(w), cb->event->xany.window, gc, x, y, 8, 8);
    }
    else if (cb->event->type == KeyPress) {      /* (7) L[ꂽꍇ    */
        /* (8) L[R[h keycode L[V{ keysym ɕϊ */
        keysym = XKeycodeToKeysym(XtDisplay(w), cb->event->xkey.keycode, 0);

        switch (keysym) {  /* (9) L[V{𒲂ׂ */
        case XK_a: printf("`a' is pressed\n"); break;
        case XK_1: printf("`1' is pressed\n"); break;
        }
    }
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, bboard, canvas;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Inputevent", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    bboard = XmCreateBulletinBoard(toplevel, "bboard", al, ac);
    XtManageChild(bboard);

    ac = 0;
    XtSetArg(al[ac], XmNwidth, 300); ac++;
    XtSetArg(al[ac], XmNheight, 300); ac++;
    canvas = XmCreateDrawingArea(bboard, "canvas", al, ac);
    XtManageChild(canvas);

    /* (1) [U͂ƂɌĂяoR[obNo^ */
    XtAddCallback(canvas, XmNinputCallback, InputEventCB, NULL);

    XtRealizeWidget(toplevel);

    /* (1) OtBbNEReLXg𐶐A`}`̐Fɐݒ */
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);
    XSetForeground(XtDisplay(canvas), gc, BlackPixelOfScreen(XtScreen(canvas)));

    XtAppMainLoop(app_context);
}
